#ifndef SWF_CLIENT_H
#define SWF_CLIENT_H

struct DataMessage {
	unsigned int request;
	unsigned int param1;
	unsigned int param2;
	unsigned int param3;
	unsigned int param4;
	unsigned int consumetime;
};

typedef struct {
 	int fd;
	int is_connected;
	unsigned int rank;
	unsigned int network_size;
	char *buffer;
	unsigned int buffer_size;
	unsigned int buffer_length;
} swf_conn;


ssize_t swfcom_read(swf_conn *con, void *buf, size_t count);
ssize_t swfcom_write(swf_conn *con, const void *buf, size_t count);

int swfcom_readv(swf_conn *con, unsigned int src, const struct iovec *vector,
               size_t count);
int swfcom_writev(swf_conn *con, unsigned int dest, const struct iovec *vector,
		size_t count);

int swfcom_buffer_add(swf_conn *con,char *addthis, unsigned int addsize);
int swfcom_buffer_throw_away_bytes(swf_conn *con,char amount);
int Tcpstuff_Get_Socket(char *host, char *port);

void swfcom_init_struct(swf_conn *con);
void swfcom_connect_with_rank(swf_conn *con,unsigned int rank);

void swfcom_finish(swf_conn *con);

void swfcom_get_size(swf_conn *con);
void swfcom_get_rank(swf_conn *con);
unsigned long swfcom_get_time(swf_conn *con);
unsigned int swfcom_consumetime(swf_conn *con, unsigned int time);
unsigned swfcom_send(swf_conn *con, unsigned dest,unsigned tag,
		unsigned size, char* buffer);
void swfcom_recv(swf_conn *con,unsigned *from, unsigned* tag, unsigned* size,
		char* buffer, unsigned int length);

unsigned swfcom_send_probe_request(swf_conn *con,unsigned* from,
	       	unsigned* tag, unsigned*size);

#endif
